# The following defines the version of compiler we are doing this for so 
# that we can do this easily as new versions come out, directly when
# rebuilding this src.rpm
%{!?compiler: %global compiler gcc}
%define compilershort %( echo %{compiler} | tr -d 0-9 )
%{!?intelversion:%define intelversion 13.0}
%{!?openmpiversion:%define openmpiversion 1.6.3}
%bcond_with default
%define zeronumversion %(echo 0%{?openmpiversion} | tr . 0)

# GCC Compiler
%if "%{compilershort}" == "gcc"
%define compilershortversion gcc
%define compilermodulename gcc
%define compilermodulefile .modulerc-gcc-%{modulebits}-999999
%endif

%if "%{compilershort}" == "intel"
%define intelmajor %( echo %{compiler} | cut -b6-7 )
%define intelminor %( echo %{compiler} | cut -b8 )
%define intelversion %{intelmajor}.%{intelminor}
%define intelversionnum %{intelmajor}%{intelminor}
%define compilershortversion intel-%{intelmajor}
%define compilermodulename intel-%{intelversion}
%if %{with default}
%define compilermodulefile .modulerc-intel-%{modulebits}-999-9.9.9
%else
%define compilermodulefile .modulerc-intel-%{modulebits}-%{intelversionnum}-9.9.9
%endif
%endif

%define modulesdestination /usr/local/share/Modules/modulefiles/openmpi
%define modulefilename %{modulesdestination}/%{compilermodulefile}

# here for different bits
%ifarch %{ix86}
%define modulebits 32
%else
%define modulebits 64
%endif

Summary: Modules to make openmpi version 
Name: openmpi%{zeronumversion}-%{compiler}-%{?with_default:global}default
Version: 1.0
Release: 2%{?dist}
License: Other
Group: Development/Languages
ExclusiveArch: i686 x86_64
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires: environment-modules >= 3.2.3

%description
This rpm contains modules configuration files to make the openmpi version %{openmpiversion}
for compiler %{compiler} the default version for loading with just
module load openmpi/%{compiler}

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{modulesdestination}
cat > $RPM_BUILD_ROOT%{modulefilename} <<ENDDEFAULT
#%Module
module-alias openmpi/%{compilershort} openmpi/%{compilermodulename}/%{openmpiversion}
ENDDEFAULT
%if "%{compilershorversion}" != "%{compilershort}"
echo module-alias openmpi/%{compilershortversion} openmpi/%{compilermodulename}/%{openmpiversion} >> $RPM_BUILD_ROOT%{modulefilename}
%endif
%if %{with default}
echo module-alias openmpi openmpi/%{compilermodulename}/%{openmpiversion} >> $RPM_BUILD_ROOT%{modulefilename}
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%dir %{modulesdestination}
%{modulefilename}

%changelog
* Wed Sep 02 2015 Josko Plazonic <plazonic@princeton.edu>
- initial build
